<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--
 *  Copyright (c) 2012-2015, Texas Instruments Incorporated
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *  *  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *  *  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *  *  Neither the name of Texas Instruments Incorporated nor the names of
 *     its contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 *  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->
<html>
<head>
    <title>IPC 3.47.02.00 Release Notes </title>
    <!-- For now, we use the doxygen style sheet -->
    <link type="text/css" rel="stylesheet" href="../../docs/doxygen/html/doxygen.css">
    <!-- doxygen's css .memproto's all have tables for a little extra pad...
         don't like tables, so give 'em a little extra left pad ourselves
    --->
    <style type="text/css">
    body {
        margin: 20px;
    }
    .memproto {
        padding-left: 6px;
    }
    </style>
</head>
<body>
<table width="100%">
  <tbody>
    <tr>
      <td bgcolor="black" width="1">
        <a href="http://www.ti.com">
          <img border=0 src="../../docs/tilogo.gif" alt="Texas Instruments">
        </a>
      </td>
      <td bgcolor="red">
        <img src="../../docs/titagline.gif" alt="Technology for Innovators(tm)">
      </td>
    </tr>
  </tbody>
</table>

<h1 align="center">IPC 3.47.02.00 Release Notes </h1>
<h2 align="center">July 2018</h2>

<p>
This IPC Release is targeted to SYS/BIOS 6-based platforms.
</p>
<p align="center">
<a href="#Introduction">Introduction</a>,
<a href="#Documentation">Documentation</a>,
<a href="#Whats_New">What's New</a>,
<a href="#Upgrade_Info">Upgrade Info</a>,
<a href="#Compatibility">Compatibility Information</a>,
<a href="#Device_Support">Device Support</a>,
<a href="#Validation">Validation Info</a>,
<a href="#Known_Issues">Known Issues</a>,
<a href="#Version">Version Information</a>,
<a href="#Support">Technical Support</a>.
</p>

<hr>

<h2><a name="Introduction">Introduction</a></h2>

<p>
The IPC product provides software connectivity between multiple
processors. Each processor may run either an HLOS (e.g. Linux, QNX)
or an RTOS (e.g. SYS/BIOS).  <!-- In addition, a
processor may also be designated as the master for another slave processor,
and may be responsible for controlling the slave processor's execution
(including boot-loading the slave).-->
</p>
<p>
The IPC product is comprised of the following</p>
    <ul>
      <li>
        <b>packages/ti.ipc</b>:  IPC interface definitions (e.g. MessageQ,
        ListMP, HeapMemMP, Notify, etc.)
      </li>
      <li>
        <b>packages/ti.sdo.ipc</b>:  BIOS implementations of
        higher-level IPC modules (e.g. MessageQ, Notify, heaps, etc.)
      </li>
      <li>
        <b>packages/ti.sdo.utils</b>: BIOS implementations of IPC
        utility modules (e.g. MultiProc, List, NameServer, etc.)
      </li>
      <li>
        <b>qnx</b>:  Contains QNX implementations of ti.ipc
      </li>
      <li>
        <b>linux</b>:  Contains Linux implementations of ti.ipc
      </li>
    </ul>

<p>These components are provided as source code and prebuilt libraries.</p>


<hr>

<h2><a name="Documentation">Documentation</a></h2>
<p>
The following documentation is available:
</p>
<ul>
  <li>
    Install Guide (BIOS) - (<a href="../../docs/IPC_Install_Guide_BIOS.pdf">local</a> |
      <a href="http://processors.wiki.ti.com/index.php/IPC_Install_Guide_BIOS">latest</a>)
  </li>
  <li>
    Install Guide (QNX) - (<a href="../../docs/IPC_Install_Guide_QNX.pdf">local</a> |
      <a href="http://processors.wiki.ti.com/index.php/IPC_Install_Guide_QNX">latest</a>)
  </li>
  <li>
    Install Guide (Linux) - (<a href="../../docs/IPC_Install_Guide_Linux.pdf">local</a> |
      <a href="http://processors.wiki.ti.com/index.php/IPC_Install_Guide_Linux">latest</a>)
  </li>
  <li>
    Install Guide (Android) - (<a href="http://processors.wiki.ti.com/index.php/IPC_Install_Guide_Android">latest</a>)
  </li>
  <li>
    User's Guide - (<!-- <a href="../../docs/IPC_Install_Guide_Linux.pdf">local</a> | -->
      <a href="http://processors.wiki.ti.com/index.php/IPC_User%27s_Guide">latest</a>)
  </li>
  <li>IPC Application Programming Interface (API) Reference
  Guide (<a href="../../docs/doxygen/html/index.html">HTML</a>)</li>
  <li>
    <a href="../../docs/cdoc/index.html">Package Reference Guide (cdoc)</a> - includes
    configuration details
  </li>
  <li>
    <a href="ipc_3_47_02_00_reports.html">Static Analysis Reports</a>
  </li>
  <li>
    <a href="ipc_3_47_02_00_manifest.html">IPC Software Manifest and License</a>
  </li>
</ul>

<p>
In addition, users are encouraged to monitor (and contribute to!) the
<a href="http://processors.wiki.ti.com">TI Wiki</a>.
</p>

<p>
Release notes from previous releases are also available in the <a
href="../../docs/relnotes_archive">relnotes_archive</a> directory.
</p>

<hr>
<h2><a name="Whats_New">What's New</a></h2>

<div class="memitem">
<div class="memproto">3.47.02.00 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-179</td>
      <td>Linux/Android: TransportRpmsg Hang During Recovery
</td>
    </tr>
    <tr>
      <td>IPC-196</td>
      <td>Linux/Android: MmRpc parameter checking
</td>
    </tr>
    <tr>
      <td>IPC-199</td>
      <td>Linux/Android: Ipc_start hangs if LAD is not started in some cases
</td>
    </tr>
    <tr>
      <td>IPC-203</td>
      <td>TransportRpmsg has wrong check for Invalid Socket
</td>
    </tr>
    <tr>
      <td>IPC-205</td>
      <td>DRA7XX: ex41_forwardmsg cannot be run back-to-back
</td>
    </tr>
    <tr>
      <td>IPC-214</td>
      <td>IPC listMP corruption
</td>
    </tr>
    <tr>
      <td>IPC-217</td>
      <td>IPC LAD Crash
</td>
    </tr>
    <tr>
      <td>IPC-229</td>
      <td>IPC examples AMMU configuration contains regions from OMAP5 that don`t exist on AM57xx
</td>
    </tr>
    <tr>
      <td>IPC-230</td>
      <td>Incorrect cache comment in dsp.cfg of OMAP-L138 ex02_messageq
</td>
    </tr>
    <tr>
      <td>IPC-231</td>
      <td>IPC ex02 DSP1 image doesn't work on AM572x EVM
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-204</td>
      <td>Android: Get AF_RPMSG value from uapi version.h instead of from bionic socket.h
</td>
    </tr>
    <tr>
      <td>IPC-206</td>
      <td>Android: move IPC binaries and libraries to vendor partition
</td>
    </tr>
    <tr>
      <td>IPC-207</td>
      <td>Update to XDCtools: 3_50_03_33 & BIOS 6_52_00_12
</td>
    </tr>
    <tr>
      <td>IPC-215</td>
      <td>Android: Fix Compiler Warnings
</td>
    </tr>
    <tr>
      <td>IPC-216</td>
      <td>Linux: Update AF_RPMSG for 2018 LTS kernel
</td>
    </tr>
    <tr>
      <td>IPC-227</td>
      <td>MessageQ_fault app for DSP1 watchdog is not working properly
</td>
    </tr>
    <tr>
      <td>IPC-228</td>
      <td>Android: Update Makefile to not use LOCAL_MODULE_PATH
</td>
    </tr>
    <tr>
      <td>IPC-234</td>
      <td>Create examples specific to AM571X SOC
</td>
    </tr>

  </tbody>
</table>
</li>

  <br />

  <li><b>IMPORTANT NOTE:</b>
  <p> The <b>Android</b> build of the IPC now outputs binaries and libraries to the vendor folder. This is done to be in compliance with Android Treble project, where SoC-specific content is taken in to vendor partition.
  <br /> When building for Android O, the binaries and libraries will be found in the vendor folder. For instance:
  <pre>
      $MYDROID/out/target/product/jacinto6evm/<b>vendor/</b>
  </pre>
  <br /> When building for Android M or earlier, the binaries and libraries will be found in the system/vendor folder. For instance:
  <pre>
      $MYDROID/out/target/product/jacinto6evm/<b>system/vendor/</b>
  </pre>
</p>
</li>

</ul>
</div>
</div>

<br />
<div class="memitem">
<div class="memproto">3.46.02.04 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-158</td>
      <td>Linux: Fix various compile warnings
</td>
    </tr>
    <tr>
      <td>IPC-166</td>
      <td>Linux: MessageQ_put should be fixed to handle Multiprocess and different transport use case
</td>
    </tr>
    <tr>
      <td>IPC-173</td>
      <td>BIOS: OMAPL138: mismatch of resource entries in resource table
</td>
    </tr>
    <tr>
      <td>IPC-176</td>
      <td>BIOS: Watchdog timers lose context on DSPs on DRA7
</td>
    </tr>
    <tr>
      <td>IPC-184</td>
      <td>Linux/Android: missing mutexattr_init call
</td>
    </tr>
    <tr>
      <td>IPC-161</td>
      <td>QNX: NameServer_delete doesn't properly cleanup if NameServer_remove isn't called
</td>
    </tr>
    <tr>
      <td>IPC-186</td>
      <td>QNX: GateMP Error Recovery Issues
</td>
    </tr>
    <tr>
      <td>IPC-191</td>
      <td>QNX: missing mutexattr_init call
</td>
    </tr>
    <tr>
      <td>IPC-195</td>
      <td>ipc-examples: add back TDA3XX examples
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-127</td>
      <td>Add back IPC support for OMAPL138
</td>
    </tr>
    <tr>
      <td>IPC-164</td>
      <td>Linux/BIOS: Rename fault to MessageQFault or MessageQFaultApp
</td>
    </tr>
    <tr>
      <td>IPC-181</td>
      <td>QNX 7.0 Support
</td>
    </tr>
    <tr>
      <td>IPC-183</td>
      <td>Android: Validate with Android N and K4.9
</td>
    </tr>

  </tbody>
</table>
</li>


</ul>
</div>
</div>

<br />
<div class="memitem">
<div class="memproto">3.45.00.00 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-151</td>
      <td>[Linux/Android] IPC: Static Analysis warnings must be fixed
</td>
    </tr>
    <tr>
      <td>IPC-141</td>
      <td>[Android] LAD: Run LAD as Application for Android
</td>
    </tr>
    <tr>
      <td>IPC-143</td>
      <td>QNX: Fix from QNX to work with QNX 7.0
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-105</td>
      <td>Prevent near accesses in all IPC code
</td>
    </tr>
    <tr>
      <td>IPC-99</td>
      <td>DRA7XX: Enable Watchdog for DSP2
</td>
    </tr>
    <tr>
      <td>IPC-100</td>
      <td>Add Ability to enable Deh without Watchdog
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li><b>IMPORTANT NOTE:</b>
  <p> The <b>Android</b> build of the LAD is now built as an Application instead of a Daemon. This results in a change in the way that LAD is launched in Android.
  <br /> It's recommended to add an Android service in the init.rc script file for the lad_dra7xx.  For instance:
  <pre>
      service lad_dra7xx /system/bin/lad_dra7xx -g
          class main
          user media
          group system
          oneshot
  </pre>
  The service can be set up to automatically launch when Android boots or manually started later:
  <pre>
      $ start lad_dra7xx
  </pre>
  Directly running the lad_dra7xx executable in Android is discouraged as the capability to enforce that only one instance is running is lost.
  <br><br>The LAD built for Linux HLOS will continue to run as a Daemon by default.
</p>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.44.01.01 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-132</td>
      <td> IPC: DSP MessageQ example fails to build in release mode
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.43.03.05 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-106</td>
      <td>Linux/Android: Android N Compiler Errors
</td>
    </tr>
    <tr>
      <td>IPC-94</td>
      <td>Update SR0 address in IPC examples to match default in kernel dtb
</td>
    </tr>
    <tr>
      <td>IPC-103</td>
      <td>[Linux/Android] Crashed M4 Prevents MessageQ_open on DSP
</td>
    </tr>
    <tr>
      <td>IPC-101</td>
      <td>SYS/BIOS: Watchdog: Wrong Register Address for Timer 13
</td>
    </tr>
    <tr>
      <td>IPC-92</td>
      <td>[Linux/Android] GateMP shouldn't map NULL Pointers or 0 sizes
</td>
    </tr>
    <tr>
      <td>IPC-128</td>
      <td>QNX: Unaligned pointer access in trace statement
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-40</td>
      <td>[QNX] Replace calls to LOGn() with GT calls for consistency
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />
<div class="memitem">
<div class="memproto">3.43.01.03 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-68</td>
      <td>Linux: ex41_forwardmsg fails if lad is started with "-g" option
</td>
    </tr>
    <tr>
      <td>IPC-69</td>
      <td>QNX: Late attach testing failure with J6-eco
</td>
    </tr>
    <tr>
      <td>IPC-77</td>
      <td>[Linux/Android] NULL pointer de-reference in TransportRpmsg_delete Error Case
</td>
    </tr>
    <tr>
      <td>IPC-67</td>
      <td>ex02_messageq linux fails on k2hk for core1-core7
</td>
    </tr>
    <tr>
      <td>IPC-70</td>
      <td>Getting error when running Linux example application with "-l" option
</td>
    </tr>
    <tr>
      <td>IPC-63</td>
      <td>IPC MessageQ Example does not complete on K2H(ELG)
</td>
    </tr>
    <tr>
      <td>IPC-12</td>
      <td>[Linux/Android] LAD NameServer Error Recovery Issues
</td>
    </tr>
    <tr>
      <td>IPC-96</td>
      <td>IPC bios build and examples build fail with xdc/bin in path in windows
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-84</td>
      <td>RTOS: ipc_n_nn_nn_nn/examples has various xxxx_elf files but no README
</td>
    </tr>
    <tr>
      <td>IPC-88</td>
      <td>IPC ARM RTOS examples should use SMP BIOS mode
</td>
    </tr>
    <tr>
      <td>IPC-2</td>
      <td>Update IPC Examples to Remove INTMEM type (K4.1)
</td>
    </tr>
    <tr>
      <td>IPC-50</td>
      <td>[QNX] Update QNX IPC to remove INTMEM type
</td>
    </tr>
    <tr>
      <td>IPC-88</td>
      <td>IPC ARM RTOS examples should use SMP BIOS mode
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />
<div class="memitem">
<div class="memproto">3.42.01.03 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-42</td>
      <td>Creation of more than one MmServiceMgr instance fails
</td>
    </tr>
    <tr>
      <td>IPC-43</td>
      <td>Android IPC Changes Required for Android Marshmallow
</td>
    </tr>
    <tr>
      <td>IPC-24</td>
      <td>Keystone messageq_multicore|xe66 fails to load to DSP with mpmcl
</td>
    </tr>
    <tr>
      <td>IPC-46</td>
      <td>[Android] LAD: Old fifos persist when LAD is terminated and restarted
</td>
    </tr>
    <tr>
      <td>IPC-47</td>
      <td>LAD: Only one instance of LAD should be allowed to run at a time
</td>
    </tr>
    <tr>
      <td>IPC-13</td>
      <td>Security issue with /dev/mem access in GateMP
</td>
    </tr>
    <tr>
      <td>IPC-12</td>
      <td>All IPC examples except explicitly GateMP fails to run out of box
</td>
    </tr>
    <tr>
      <td>IPC-61</td>
      <td>Watchdog: Release builds continuously time out during application Idle
</td>
    </tr>
    <tr>
      <td>IPC-71</td>
      <td>SYS/BIOS: GateMP startup with hostSupport Fails for DSP
</td>
    </tr>
    <tr>
      <td>IPC-60</td>
      <td>Need to adjust cache map in examples according to the latest linux driver and dtb
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>IPC-3</td>
      <td>IPC support for K2G: ARM RTOS/ DSP RTOS use case 
</td>
    </tr>
    <tr>
      <td>IPC-45</td>
      <td>Add MessageQ example for K2G ( and also for K2H| K2L| K2E) 
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />
<div class="memitem">
<div class="memproto">3.41.00.08 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00118895</td>
      <td>Missing access qualifier FAR in RPMessage module
</td>
    </tr>
    <tr>
      <td>SDOCM00114683</td>
      <td>Display QueueId in ROV for reserved queues
</td>
    </tr>
    <tr>
      <td>SDOCM00116675</td>
      <td>Corrupted trace buffer causes QNX IPC driver to crash during recovery
</td>
    </tr>
    <tr>
      <td>SDOCM00069628</td>
      <td>GateMPSupportNull.getNumResources should return '0'
</td>
    </tr>
    <tr>
      <td>SDOCM00115099</td>
      <td>Example ex01_hello readme needs updates
</td>
    </tr>
    <tr>
      <td>SDOCM00115293</td>
      <td>Linux transport interfaces need documentation
</td>
    </tr>
    <tr>
      <td>SDOCM00115347</td>
      <td>Keystone 2 Interrupt module doesn't validate HOST
</td>
    </tr>
    <tr>
      <td>SDOCM00116995</td>
      <td>Using C++ compiler raises errors
</td>
    </tr>
    <tr>
      <td>SDOCM00119188</td>
      <td>ipc.aa15fg and utils.aa15fg pre-built libs are missing from respective directories.
</td>
    </tr>
    <tr>
      <td>SDOCM00077054</td>
      <td>NameServer UG needs to correctly document permissible calling contexts for NS APIs
</td>
    </tr>
    <tr>
      <td>SDOCM00117331</td>
      <td>IPC test ping_rpmsg is broken for recent Linux 3.14 releases
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00119643</td>
      <td>Consolidate Interrupt and NotifyCircSetup modules on Keystone 2
</td>
    </tr>
    <tr>
      <td>SDOCM00106441</td>
      <td>KS2: Remove DNUM-based vring assumptions
</td>
    </tr>
    <tr>
      <td>SDOCM00119574</td>
      <td>[QNX] Enable IPC3 to build with QNX 6.5
</td>
    </tr>
    <tr>
      <td>SDOCM00116175</td>
      <td>More graceful MessageQ recovery in QNX
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.40.00.06 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00117013</td>
      <td>SharedRegion-related asserts are incorrect
</td>
    </tr>
    <tr>
      <td>SDOCM00117958</td>
      <td>LAD crashes w/ segfault when NameServer_create() is called after NameServer() delete
</td>
    </tr>
    <tr>
      <td>SDOCM00117156</td>
      <td>Resource entries that are not aligned to 1MB boundary needs to be handled correctly
</td>
    </tr>
    <tr>
      <td>SDOCM00104833</td>
      <td>MessageQMulti application does not support numThreads > 10
</td>
    </tr>
    <tr>
      <td>SDOCM00114069</td>
      <td>IPC custom build does not include file from ti/ipc
</td>
    </tr>
    <tr>
      <td>SDOCM00118440</td>
      <td>Remove DRA7XX references from example ex46_graph config.bld
</td>
    </tr>
    <tr>
      <td>SDOCM00118433</td>
      <td>Examples use incorrect link command
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00115404</td>
      <td>IPC user-mode errors (Linux) should not go to STDOUT
</td>
    </tr>
    <tr>
      <td>SDOCM00116391</td>
      <td>Increase default poll rate of the default gate in GateMP_setup in QNX
</td>
    </tr>
    <tr>
      <td>SDOCM00118017</td>
      <td>RPMessage (Linux) has large data footprint, make it configurable
</td>
    </tr>
    <tr>
      <td>SDOCM00117361</td>
      <td>Need to update BIOS version to support Power module for C66 on DRA7xx
</td>
    </tr>
    <tr>
      <td>SDOCM00115093</td>
      <td>Multiple heap support for MessageQ (Linux)
</td>
    </tr>
    <tr>
      <td>SDOCM00117446</td>
      <td>Power Management for DRA7xx DSP on Linux
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.36.00.07 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00115129</td>
      <td>DSP aborts when patched with large cluster base ID
</td>
    </tr>
    <tr>
      <td>SDOCM00115127</td>
      <td>GateMP_open crashes on Keystone 2
</td>
    </tr>
    <tr>
      <td>SDOCM00114083</td>
      <td>Upon failure from DLOAD_get_section_offset(), QNX IPC generates multiple assertions as opposed to exiting cleanly
</td>
    </tr>
    <tr>
      <td>SDOCM00114783</td>
      <td>pthread_mutex_destroy is not called in IPC
</td>
    </tr>
    <tr>
      <td>SDOCM00115434</td>
      <td>NameServer_delete in LAD daemon leaks memory
</td>
    </tr>
    <tr>
      <td>SDOCM00115067</td>
      <td>Parallel build support in IPC examples
</td>
    </tr>
    <tr>
      <td>SDOCM00115428</td>
      <td>Incorrect return status from NameServer_delete (Linux)
</td>
    </tr>
    <tr>
      <td>SDOCM00115143</td>
      <td>Improper timeout handling in MessageQ_get (Linux)
</td>
    </tr>
    <tr>
      <td>SDOCM00115768</td>
      <td>Incorrect check for invalid pointer in Ipc_detach
</td>
    </tr>
    <tr>
      <td>SDOCM00115958</td>
      <td>'make install' for QNX is not exporting transport interface header files
</td>
    </tr>
    <tr>
      <td>SDOCM00114745</td>
      <td>Ipc_transportConfig has race window where factory is overwritten
</td>
    </tr>
    <tr>
      <td>SDOCM00115098</td>
      <td>New MultiProc cdoc links for "See Also" are garbled
</td>
    </tr>
    <tr>
      <td>SDOCM00115373</td>
      <td>NameServer local get methods are missing on Linux
</td>
    </tr>
    <tr>
      <td>SDOCM00115294</td>
      <td>NameServer_create and NameServer_add sometimes fail in QNX
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00115106</td>
      <td>Expose functions in TiIpcFxns.h as public API
</td>
    </tr>
    <tr>
      <td>SDOCM00114946</td>
      <td>IPC Watchdog module should allow user-configurable timer assignments
</td>
    </tr>
    <tr>
      <td>SDOCM00115108</td>
      <td>The default value ProcMgr_MAX_MEMORY_REGIONS should be increased in QNX
</td>
    </tr>
    <tr>
      <td>SDOCM00116094</td>
      <td>Command Line Options for LAD to override config params
</td>
    </tr>
    <tr>
      <td>SDOCM00114951</td>
      <td>Host-only IPC communication (Linux, no DSP support)
</td>
    </tr>
    <tr>
      <td>SDOCM00100361</td>
      <td>Error Recovery: When slave crashes, apps using the slave should be able to recover
</td>
    </tr>
    <tr>
      <td>SDOCM00114663</td>
      <td>Add DRA7XX DSP2 support to QNX
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memitem">
<div class="memproto">3.35.00.05 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00103540</td>
      <td>Incorrect number of hardware spin locks on DRA7XX
</td>
    </tr>
    <tr>
      <td>SDOCM00115028</td>
      <td>"struct fw_rsc_intmem" mismatch between QNX and IPC 3.30
</td>
    </tr>
    <tr>
      <td>SDOCM00108142</td>
      <td>QNX code in qnx/src/ipc3x_dev needs cleanup
</td>
    </tr>
    <tr>
      <td>SDOCM00115035</td>
      <td>Watchdog module device validation & configuration should be in module$use method, not module$meta$init
</td>
    </tr>
    <tr>
      <td>SDOCM00115038</td>
      <td>Notify mailbox driver is clearing wrong fifo during init phase
</td>
    </tr>
    <tr>
      <td>SDOCM00115050</td>
      <td>Race condition in QNX when IPU2 is exchanging messages with host while DSP1 or IPU1 is doing the same
</td>
    </tr>
    <tr>
      <td>SDOCM00115024</td>
      <td>IPC ping rpmsg unit-test hangs when run on K2L
</td>
    </tr>
    <tr>
      <td>SDOCM00115043</td>
      <td>Recovery is not working in QNX on 'late-attached' cores
</td>
    </tr>
    <tr>
      <td>SDOCM00113501</td>
      <td>Clean up QNX build output
</td>
    </tr>
    <tr>
      <td>SDOCM00114478</td>
      <td>Incorrect thread safety in MessageQ_setup (Linux)
</td>
    </tr>
    <tr>
      <td>SDOCM00115026</td>
      <td>ex13_notifypeer example needs ping message from DSP to EVE
</td>
    </tr>
    <tr>
      <td>SDOCM00115042</td>
      <td>NotifyDriverMbx on Vayu should not use Ipc module
</td>
    </tr>
    <tr>
      <td>SDOCM00115034</td>
      <td>"struct fw_rsc_intmem" mismatch between Linux 3.14 and IPC 3.30.0.9
</td>
    </tr>
    <tr>
      <td>SDOCM00114110</td>
      <td>IPC custom build failure with XDCtools core product
</td>
    </tr>
    <tr>
      <td>SDOCM00114409</td>
      <td>vring initialization in QNX is not clearing the correct area
</td>
    </tr>
    <tr>
      <td>SDOCM00115030</td>
      <td>Ipc family Settings.xs needs to add F28377D
</td>
    </tr>
    <tr>
      <td>SDOCM00115031</td>
      <td>libipc and libutils are not built for dynamic linking in QNX IPC
</td>
    </tr>
    <tr>
      <td>SDOCM00115036</td>
      <td>MessageQMulti unit-test gets an out of heap memory error when run on K2E or K2L
</td>
    </tr>
    <tr>
      <td>SDOCM00115039</td>
      <td>Ipc_attach() race on multiple cores corrupts Ipc_Reserved structs in SR0
</td>
    </tr>
    <tr>
      <td>SDOCM00114518</td>
      <td>MessageQ_setMsgPri overwrites entire flags field
</td>
    </tr>
    <tr>
      <td>SDOCM00113915</td>
      <td>GateMPApp's output should be made less verbose
</td>
    </tr>
    <tr>
      <td>SDOCM00115049</td>
      <td>Incorrect Assert_isTrue in RPMessage_recv
</td>
    </tr>
    <tr>
      <td>SDOCM00115051</td>
      <td>IPC custom build failure with XDCtools core product
</td>
    </tr>
    <tr>
      <td>SDOCM00106179</td>
      <td>Remove/circumvent error messages from MessageQCopy_send at startup in QNX resource manager
</td>
    </tr>
    <tr>
      <td>SDOCM00114392</td>
      <td>Interrupt module on tci6638 does not support clusters
</td>
    </tr>
    <tr>
      <td>SDOCM00114390</td>
      <td>Incorrect procId in NameServer_get used by lad daemon
</td>
    </tr>
    <tr>
      <td>SDOCM00115053</td>
      <td>LAD's GateMP fails to start when built for Android's Lollipop
</td>
    </tr>
    <tr>
      <td>SDOCM00115047</td>
      <td>Optimization using VRING_USED_F_NO_NOTIFY is broken on QNX, and interrupts are not sent when race occurs
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00113149</td>
      <td>GateMP host-support should work when SharedRegion 0 has a physical address that is different from its virtual address
</td>
    </tr>
    <tr>
      <td>SDOCM00114393</td>
      <td>ex44_compute, new example for Keystone II
</td>
    </tr>
    <tr>
      <td>SDOCM00114391</td>
      <td>IPC cluster support is missing on Linux implementation
</td>
    </tr>
    <tr>
      <td>SDOCM00114908</td>
      <td>Add reserved queue support to QNX
</td>
    </tr>
    <tr>
      <td>SDOCM00114354</td>
      <td>IPC Manager needs a public header file
</td>
    </tr>
    <tr>
      <td>SDOCM00114730</td>
      <td>Add support for reserved message queues on Linux/Keystone II
</td>
    </tr>
    <tr>
      <td>SDOCM00113638</td>
      <td>Rename paths to ipc-trace to not require a priori knowledge of MultiProc ids in QNX
</td>
    </tr>
    <tr>
      <td>SDOCM00114696</td>
      <td>Add method to return address of shared region entry
</td>
    </tr>
    <tr>
      <td>SDOCM00115022</td>
      <td>Loading/unloading individual cores while keeping other cores running in QNX IPC
</td>
    </tr>
    <tr>
      <td>SDOCM00114964</td>
      <td>Processor data array size should match cluster size
</td>
    </tr>
    <tr>
      <td>SDOCM00113609</td>
      <td>Add version support for MessageQ_Params structure
</td>
    </tr>
    <tr>
      <td>SDOCM00114926</td>
      <td>Modify examples on Linux to use installed IPC product
</td>
    </tr>
    <tr>
      <td>SDOCM00114985</td>
      <td>MessageQ macro for extracting destination address from message header
</td>
    </tr>
    <tr>
      <td>SDOCM00108403</td>
      <td>Enable pluggable MessageQ transports on Linux
</td>
    </tr>
    <tr>
      <td>SDOCM00108118</td>
      <td>Need an IPC example to show how to send shmemallocator buffers using MessageQ
</td>
    </tr>
    <tr>
      <td>SDOCM00111686</td>
      <td>NameServer max name length needs to be made more easily configurable
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.30.00.09 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00107419</td>
      <td>IPC build warning in RPMessage.c
</td>
    </tr>
    <tr>
      <td>SDOCM00112918</td>
      <td>MessageQ_open() from multiple threads can get stuck
</td>
    </tr>
    <tr>
      <td>SDOCM00108130</td>
      <td>IPC custom library build creates empty folder
</td>
    </tr>
    <tr>
      <td>SDOCM00112680</td>
      <td>IPC for Concerto has incorrect NotifyDriverCirc_enable()/enableEvent()
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00113036</td>
      <td>Add ex02_messageq example for DRA7xx, all-BIOS
</td>
    </tr>
    <tr>
      <td>SDOCM00113039</td>
      <td>Add ex13_notifypeer example for DRA7xx, all-BIOS
</td>
    </tr>
    <tr>
      <td>SDOCM00113034</td>
      <td>TDA3xx device support
</td>
    </tr>
    <tr>
      <td>SDOCM00106423</td>
      <td>Update to CCSv6-compatible BIOS and XDC versions
</td>
    </tr>
    <tr>
      <td>SDOCM00113035</td>
      <td>Add ex01_hello example for DRA7xx, all-BIOS
</td>
    </tr>
    <tr>
      <td>SDOCM00112254</td>
      <td>Add IPC support for Soprano
</td>
    </tr>
    <tr>
      <td>SDOCM00112956</td>
      <td>Remove OMAP5 Linux and QNX support
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.23.00.01 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00112106</td>
      <td>Timed-out NameServer requests from host causes subsequent requests to receive out-of-sequence responses
</td>
    </tr>
    <tr>
      <td>SDOCM00108594</td>
      <td>MultiProc_self() returns bogus value on QNX
</td>
    </tr>
    <tr>
      <td>SDOCM00108585</td>
      <td>IpcPower has incorrect interrupts
</td>
    </tr>
    <tr>
      <td>SDOCM00112581</td>
      <td>GateMP_create on Linux sets resourceId incorrectly
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00108584</td>
      <td>Support QNX 6.6
</td>
    </tr>
    <tr>
      <td>SDOCM00108582</td>
      <td>QNX Late Attach support for DRA7XX
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.22.02.11 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00112064</td>
      <td>Reduce memory usage for K2E tests (including update to XDC 3.25.06.96)
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00108138</td>
      <td>Improved MmRpc/MmService error handling when app dies
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.22.01.08 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00108167</td>
      <td>Uninitialized variable in notify driver template file
</td>
    </tr>
    <tr>
      <td>SDOCM00108149</td>
      <td>Incorrect mailbox index computation in NotifySetup for v7M and v7A
</td>
    </tr>
    <tr>
      <td>SDOCM00108114</td>
      <td>Link error when building with DCE on IPU/Vayu
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00108135</td>
      <td>Allow users to disable QNX watchdog
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />


<div class="memitem">
<div class="memproto">3.22.00.05 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00106580</td>
      <td>Fix KS2 tests to ensure Linux-owned memory (including vrings and vring buffers) are non-cached
</td>
    </tr>
    <tr>
      <td>SDOCM00107256</td>
      <td>QNX: Need to update the help text in ipc_trace_daemon for -t option
</td>
    </tr>
    <tr>
      <td>SDOCM00107743</td>
      <td>Build.getDefaultCustomCCOpts() does not remove optimization flags for debug builds
</td>
    </tr>
    <tr>
      <td>SDOCM00106156</td>
      <td>Race conditions in QNX VirtQueue-based MessageQ
</td>
    </tr>
    <tr>
      <td>SDOCM00104834</td>
      <td>MessageQ_create cannot create more than 52 MessageQ's
</td>
    </tr>
    <tr>
      <td>SDOCM00106949</td>
      <td>IPC interrupt preempts itself on ARP32 (EVE)
</td>
    </tr>
    <tr>
      <td>SDOCM00106336</td>
      <td>NameServerMessageQ copy of name is not copying null terminated character
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00107470</td>
      <td>Detect slave-side internal exceptions and restart slaves (OMAP5 IPU, DRA7XX IPU2)
</td>
    </tr>
    <tr>
      <td>SDOCM00106182</td>
      <td>Introduce IPC_DEBUG env var to simplify enabling trace
</td>
    </tr>
    <tr>
      <td>SDOCM00107471</td>
      <td>Add watchdog to detect slave crashes and restart (OMAP5 IPU, DRA7XX IPU2)
</td>
    </tr>
    <tr>
      <td>SDOCM00106428</td>
      <td>Add notify mailbox driver support on DRA7xx (DSP, EVE)
</td>
    </tr>
    <tr>
      <td>SDOCM00106644</td>
      <td>Move examples/archives/* to examples/*
</td>
    </tr>
    <tr>
      <td>SDOCM00107765</td>
      <td>Need a way to disable recovery mechanism in QNX IPC resource manager
</td>
    </tr>
    <tr>
      <td>SDOCM00107904</td>
      <td>Add option to set permissions on LAD's working directory
</td>
    </tr>
    <tr>
      <td>SDOCM00106584</td>
      <td>Add notify mailbox driver support on DRA7xx (IPU, HOST)
</td>
    </tr>
    <tr>
      <td>SDOCM00093822</td>
      <td>DRA7XX: Optimize Interrupt Handler for EVEs, DSPs and IPUs
</td>
    </tr>
    <tr>
      <td>SDOCM00107479</td>
      <td>Introduce internal memory resource type
</td>
    </tr>
    <tr>
      <td>SDOCM00105667</td>
      <td>Eliminate need to specify carveoutAddr, carveoutSize and mmuEnable in Syslink_Override_Params on QNX
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.21.00.07 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00106267</td>
      <td>OMAP5 and DRA7XX Linux examples should use TOOLCHAIN_PREFIX
</td>
    </tr>
    <tr>
      <td>SDOCM00106019</td>
      <td>IPC makefile template does not honor Build.customCCOpts
</td>
    </tr>
    <tr>
      <td>SDOCM00105512</td>
      <td>MessageQ_create() fails on Linux if unnamed
</td>
    </tr>
    <tr>
      <td>SDOCM00106318</td>
      <td>LAD must remove existing PID response files before restarting
</td>
    </tr>
    <tr>
      <td>SDOCM00106117</td>
      <td>ti_sdo_ipc_GateMP_getSharedAddr needs to be reverted to its original implementation
</td>
    </tr>
    <tr>
      <td>SDOCM00106278</td>
      <td>QNX DRA7XX: prevent race condition when HOST cannot handle mailbox interrupts quickly enough
</td>
    </tr>
    <tr>
      <td>SDOCM00106271</td>
      <td>CCS variable name for IPC (IPC_CG_ROOT) is broken
</td>
    </tr>
    <tr>
      <td>SDOCM00106643</td>
      <td>Example makefile should use PLATFORM not DEVICE
</td>
    </tr>
    <tr>
      <td>SDOCM00106093</td>
      <td>ex02_messageq slaves all create same named queue
</td>
    </tr>
    <tr>
      <td>SDOCM00106450</td>
      <td>HeapMemMP_free fails to cache invalidate freed memory region containing stale data for old free list header
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00103659</td>
      <td>Add pkg-config support on Linux side builds
</td>
    </tr>
    <tr>
      <td>SDOCM00105164</td>
      <td>Provide MessageQ example on DRA7XX Linux and QNX showing multiple transports
</td>
    </tr>
    <tr>
      <td>SDOCM00105868</td>
      <td>Update to BIOS 6.37 stream
</td>
    </tr>
    <tr>
      <td>SDOCM00105590</td>
      <td>Add DRA7XX IPU1 support (running SMP BIOS) to QNX
</td>
    </tr>
    <tr>
      <td>SDOCM00106044</td>
      <td>Add support for 66AK2E and TCI6630K2L
</td>
    </tr>
    <tr>
      <td>SDOCM00103676</td>
      <td>Introduce GateMP on Linux
</td>
    </tr>
    <tr>
      <td>SDOCM00106228</td>
      <td>Update OMAP5 and DRA7XX memory maps to match SDKs
</td>
    </tr>
    <tr>
      <td>SDOCM00106383</td>
      <td>Remove C6x COFF support
</td>
    </tr>
    <tr>
      <td>SDOCM00106314</td>
      <td>Change LADs working directory to /data on Android
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.20.00.06 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00104759</td>
      <td>TransportCirc should allow Swi priority to be configurable
</td>
    </tr>
    <tr>
      <td>SDOCM00102085</td>
      <td>IPC Examples would not build when extracted in the examples directory
</td>
    </tr>
    <tr>
      <td>SDOCM00104913</td>
      <td>Linux tests issue compiler warning when DRM_PREFIX isn't set
</td>
    </tr>
    <tr>
      <td>SDOCM00103636</td>
      <td>packages/ti/ipc/tests/package.bld doesn't -DRPMSG_NS_2_0 for OMAP5 which currently breaks only ping_rpmsg
</td>
    </tr>
    <tr>
      <td>SDOCM00104907</td>
      <td>QNX loader fails to load code/data into slave's internal memory
</td>
    </tr>
    <tr>
      <td>SDOCM00102068</td>
      <td>Crash recovery failing for QNX OMAP5 DSP
</td>
    </tr>
    <tr>
      <td>SDOCM00103679</td>
      <td>Linux MessageQ_get() can discard msgs when a msg is available from more than one remote core
</td>
    </tr>
    <tr>
      <td>SDOCM00104304</td>
      <td>Resolve Concerto IPC stress test failures
</td>
    </tr>
    <tr>
      <td>SDOCM00104725</td>
      <td>Fix ti/ipc/rpmsg/virtio_ring.h compile warning
</td>
    </tr>
    <tr>
      <td>SDOCM00104761</td>
      <td>VirtQueue notification on OMAP-L138 and TCI663X has a race condition
</td>
    </tr>
    <tr>
      <td>SDOCM00103727</td>
      <td>QNX 'make install' is missing MessageQ and related headers/libs
</td>
    </tr>
    <tr>
      <td>SDOCM00103112</td>
      <td>OMAP5 does not have a default Notify proxy delegate set in Settings.xs
</td>
    </tr>
    <tr>
      <td>SDOCM00104719</td>
      <td>RPMessage crash after 64k messages
</td>
    </tr>
    <tr>
      <td>SDOCM00104300</td>
      <td>Remove static allocation of IPU_MEM_IOBUFS memory in OMAP5 QNX
</td>
    </tr>
    <tr>
      <td>SDOCM00103794</td>
      <td>Ducati trace thread steals early slave-side trace and terminates afterwards
</td>
    </tr>
    <tr>
      <td>SDOCM00102268</td>
      <td>ipc resource manager process in QNX does not terminate correctly after MessageQ is used
</td>
    </tr>
    <tr>
      <td>SDOCM00104100</td>
      <td>ROV for TransportCirc/NotifyDriverCirc does not work with different baseIdOfCluster
</td>
    </tr>
    <tr>
      <td>SDOCM00104726</td>
      <td>Fix RcmServer.c compile warning
</td>
    </tr>
    <tr>
      <td>SDOCM00104049</td>
      <td>MessageQ_open() returns not found when given queue actually exists
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00099002</td>
      <td>Make "LibType_Debug" build profile be similar to LibType_Custom but with no optimizations. Stop exporting package lib
</td>
    </tr>
    <tr>
      <td>SDOCM00103725</td>
      <td>Enable builds without SMP libraries
</td>
    </tr>
    <tr>
      <td>SDOCM00103723</td>
      <td>Introduce Android support for DRA7XX
</td>
    </tr>
    <tr>
      <td>SDOCM00103415</td>
      <td>Align build variables/names across OS's in products.mak
</td>
    </tr>
    <tr>
      <td>SDOCM00104241</td>
      <td>NameServer_create/delete needs to support reference counting
</td>
    </tr>
    <tr>
      <td>SDOCM00104525</td>
      <td>Add support for Linux 3.9+ kernels which need newer AF_RPMSG definition
</td>
    </tr>
    <tr>
      <td>SDOCM00104716</td>
      <td>Add ex11_ping example for C6678
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.10.00.08 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00102067</td>
      <td>QNX multiprocess MessageQ stress tests are failing
</td>
    </tr>
    <tr>
      <td>SDOCM00102137</td>
      <td>QNX makefiles shouldn't 'install' when only building libs
</td>
    </tr>
    <tr>
      <td>SDOCM00102328</td>
      <td>Setting KERNEL_INSTALL_DIR for Keystone fails during MmRpc build
</td>
    </tr>
    <tr>
      <td>SDOCM00102258</td>
      <td>MultiProc names for TCI6636 should match TCI6638
</td>
    </tr>
    <tr>
      <td>SDOCM00102060</td>
      <td>Remove unused procIds in vayu/NotifySetup module
</td>
    </tr>
    <tr>
      <td>SDOCM00102548</td>
      <td>When only Mmrpc is used on the IPU and MessageQ is used on the DSP, MessageQ_open would not succeed
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00099787</td>
      <td>MessageQ_free needs a hook function
</td>
    </tr>
    <tr>
      <td>SDOCM00099785</td>
      <td>MessageQ_create should allow a queueId to be specified instead of finding free slot
</td>
    </tr>
    <tr>
      <td>SDOCM00102317</td>
      <td>Add support for TCI6636
</td>
    </tr>
    <tr>
      <td>SDOCM00103402</td>
      <td>Introduce GateMP on QNX
</td>
    </tr>
    <tr>
      <td>SDOCM00102149</td>
      <td>Update Linux toolchain to recent SDK-compatible Linaro versions
</td>
    </tr>
    <tr>
      <td>SDOCM00101419</td>
      <td>Enable ipc-bios.mak to build a subset of platforms for a given target
</td>
    </tr>
    <tr>
      <td>SDOCM00103504</td>
      <td>Introduce MmRpc_use()/release() enabling apps to declare when data buffers are in use across calls
</td>
    </tr>
    <tr>
      <td>SDOCM00100158</td>
      <td>Introduce Linux support for OMAP5
</td>
    </tr>
    <tr>
      <td>SDOCM00102417</td>
      <td>Remove unsupported example simVayu platforms
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<div class="memitem">
<div class="memproto">3.00.00.20 </div>

<div class="memdoc">
<ul>
  <li>The following defects were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00098436</td>
      <td>"ti_sdo_ipc_init" section needs to be padded to cacheline size
</td>
    </tr>
    <tr>
      <td>SDOCM00098440</td>
      <td>ipc.mak is broken in Windows cmd shell
</td>
    </tr>
    <tr>
      <td>SDOCM00098522</td>
      <td>The IPC mailbox drivers for M3 on TI81XX and C6A8149 does not work for SMP BIOS
</td>
    </tr>

  </tbody>
</table>
</li>
  <br />

  <li>The following enhancements were resolved:
<table width="100%">
  <colgroup width="20%">
  <tbody>
    <tr>
      <td><b>ID</b></td>
      <td><b>Headline</b></td>
    </tr>
    <tr>
      <td>SDOCM00097544</td>
      <td>Add support for polling for occurrence of interrupts on OMAPL138
</td>
    </tr>
    <tr>
      <td>SDOCM00097853</td>
      <td>Remove ti.sdo.io* content (no longer supported)
</td>
    </tr>
    <tr>
      <td>SDOCM00097181</td>
      <td>IPC should provide makefile-based examples
</td>
    </tr>
    <tr>
      <td>SDOCM00098543</td>
      <td>Introduce Linux support for TCI6638
</td>
    </tr>
    <tr>
      <td>SDOCM00098458</td>
      <td>Add rproc resource table accessor methods for vring addrs (BIOS-side)
</td>
    </tr>

  </tbody>
</table>
</li>

</ul>
</div>
</div>

<br />

<hr>
<h2><a name="Upgrade_Info">Upgrade Information</a></h2>
<p>
The IPC packages are available in the "packages/"
subdirectory of the product.  If you have a previous release of the
IPC product, you can install this release next to it, and
modify your build scripts/makefiles to use this newer release.</p>
<h2><a name="Compatibility"><font color="red">Compatibility Breaks!</font></a></h2>
<ul>
  <li>IPC 3.47.02.00 requires system integrators to update
  the following dependencies:
    <ul>
      <li>XDC Tools <b>3.50.03.33.core</b> (or compatible)</li>
      <li>SYS/BIOS <b>6.52.00.12</b> (or compatible)</li>
    </ul>
  </li>
  <li>SYS/BIOS 6.51 requires system integrators to update the GCC version to 6.3.1 or greater
  for A15 targets. Therefore GCC version 6.3.1 is required starting in IPC 3.47.00.00 release.
  As part of this change, the linker fpu library path for A15 GCC projects needs to be updated for
  the new GCC toolchain:
    <ul>
       <li>Change "LDLIBS = -L$(BIOS_INSTALL_DIR)/packages/gnu/targets/arm/libs/install-native/arm-none-eabi/lib/<b>fpu</b>" to
       "LDLIBS = -L$(BIOS_INSTALL_DIR)/packages/gnu/targets/arm/libs/install-native/arm-none-eabi/lib/<b>hard --specs=nano.specs</b>"</li>
       <li>For more information see http://processors.wiki.ti.com/index.php/SYS/BIOS_with_GCC_(CortexA)#Migrating_existing_GCC_projects_to_SYS.2FBIOS_v6.51</li>
    </ul>
  </li>
</ul>

<p>
Note, if you're upgrading from a release earlier than IPC 3.00, be
sure to review the <b>Upgrade</b> section for each of the releases between
your current release and this one.  Previous release notes are
available in the <a href="../../docs/relnotes_archive">relnotes_archive</a> directory.
</p>


<hr>
<h2><a name="Device_Support">Device Support</a></h2>

<p>
This release supports the following devices (though examples are not provided for all):
  <ul>
    <li><a href="http://focus.ti.com/docs/prod/folders/print/tms320c6670.html">TMS320C6670</a></li>
    <li><a href="http://focus.ti.com/docs/prod/folders/print/tms320c6678.html">TMS320C6678</a></li>
<!--
    <li><a href="http://focus.ti.com/docs/prod/folders/print/tms320c6472.html">TMS320C6472</a></li>
    <li><a href="http://focus.ti.com/docs/prod/folders/print/tms320c6474.html">TMS320C6474</a></li>
    <li><a href="http://focus.ti.com/docs/prod/folders/print/omap-l138.html">OMAPL138</a></li>
    <li><a href="http://focus.ti.com/apps/docs/gencontent.tsp?contentId=52385&appId=1">TMS320DA830</a></li>
    <li><a href="http://focus.ti.com/docs/prod/folders/print/tms320dm6446.html">TMS320CDM6446</a></li>
    <li><a href="http://focus.ti.com/apps/docs/gencontent.tsp?contentId=52385&appId=1">OMAPL137</a></li>
    <li><a href="http://focus.ti.com/docs/prod/folders/print/omap3530.html">OMAP3530</a></li>
    <li><a href="http://focus.ti.com/general/docs/wtbu/wtbuproductcontent.tsp?templateId=6123&navigationId=12843&contentId=53243">OMAP4430</a></li>
    <li><a href="http://focus.ti.com/docs/prod/folders/print/tms320dm8168.html">TMS320TI816X</a></li>
    <li><a href="http://focus.ti.com/docs/prod/folders/print/tms320dm8148.html">TMS320TI814X</a></li>
    <li><a href="http://www.ti.com/product/f28m35h52c">F28M35X (Concerto)</a></li>
    <li><a href="http://www.ti.com/product/tms320c6654">TMS320C6654/55/57</a></li>
    <li>TMS320TI813X</li>
    <li>TMS320TI811X</li>
    <li>TMS320C6A8149</li>
-->
    <li>OMAP-L138 - Linux on HOST, SYS/BIOS on DSP</li>
    <li>TCI6638K2K (Keystone II) - Linux on HOST, SYS/BIOS on HOST, C66 DSPs</li>
    <li>TCI6636K2H (Keystone II) - Linux on HOST, SYS/BIOS on HOST, C66 DSPs</li>
    <li>TCI6630K2L (Keystone II) - Linux on HOST, SYS/BIOS on HOST, C66 DSPs</li>
    <li>66AK2E (Keystone II) - Linux on HOST, SYS/BIOS, HOST on C66 DSP</li>
    <li>TCI66AK2G02 (Keystone II) - Linux on HOST, SYS/BIOS on C66 DSP</li>
    <li>DRA7XX (Vayu)
      <ul>
        <li>SYS/BIOS on HOST, DSP(s), EVE(s), SMP-BIOS on IPU(s)</li>
        <li>SYS/BIOS on HOST, DSP(s), EVE(s), IPU1-0, IPU1-1, SMP-BIOS on IPU2
        </li>
        <li>QNX on HOST, SYS/BIOS on DSP1, SMP-BIOS on IPU(s)</li>
        <li>Linux on HOST, SYS/BIOS on DSP1 and DSP2, SMP-BIOS on IPU1
        and IPU2</li>
      </ul>
    </li>
  </ul>
</p>


<hr>
<h2><a name="Validation">Validation</a></h2>
<p>
This release was built and validated against using the following software
components.  Please use the versions below, or compatible:
</p>

<ul>
<!-- Note, these versions are autogenerated -->
  <li>XDCtools <b>3.50.03.33.core</b></li>
  <li>SYS/BIOS <b>6.52.00.12</b></li>
  <li>Pre-built binaries were built with the following toolchains:
    <ul>
<!-- autogenerated list -->
      <li>gnu.targets.arm.A15F - <b>6.3.1</b></li>
      <li>ti.targets.arm.elf.M4 - <b>16.9.2</b></li>
      <li>ti.targets.arp32.elf.ARP32 - <b>1.0.0</b></li>
      <li>ti.targets.elf.C66 - <b>8.1.3</b></li>
    </ul>
<!-- TODO - add Linux kernel version details- per device -->
  <li>In addition, binaries for LINUX & QNX were built with following toolchains for validation:</b></li>
    <ul>
      <li>Linux GCC toolchain (ARMV7) - <b>Linaro 4.7-2013.03-20130313</b></li>
      <li>Linux GCC toolchain (ARMV5) - <b>Linaro 6.2.1-ti2017.01-armv5-x86_64</b></li>
      <li>QNX <b>7.0.0, 6.6.0 with additional patches applied depending on the version of the QNX BSP. Refer to the BSP documentation for more details.</b></li>
    </ul>
  </li>
</ul>

<p>
This release was validated using the following hardware platforms
(though others are supported):
  <ul>
    <li>TCI6638K2K (Keystone II) - Linux on HOST, SYS/BIOS on HOST, C66 DSPs</li>
    <li>TCI6630K2L (Keystone II) - Linux on HOST, SYS/BIOS on HOST, C66 DSPs</li>
    <li>66AK2E (Keystone II) - Linux on HOST, SYS/BIOS on HOST, C66 DSPs</li>
    <li>66AK2G (Keystone II) - Linux on HOST, SYS/BIOS on HOST, C66 DSPs</li>
    <li>OMAPL138 - Linux on HOST, SYS/BIOS on C66 DSPs</li>
    <li>DRA7XX (Vayu)
      <ul>
        <li>SYS/BIOS on HOST, DSP(s), EVE(s), SMP-BIOS on IPU(s)</li>
        <li>SYS/BIOS on HOST, DSP(s), EVE(s), IPU1-0, IPU1-1, SMP-BIOS on IPU2
        </li>
        <li>QNX on HOST, SYS/BIOS on DSP1, SMP-BIOS on IPU(s)</li>
        <li>Linux on HOST, SYS/BIOS on DSP1 and DSP2, SMP-BIOS on IPU1
        and IPU2</li>
        <li>Android on HOST, SYS/BIOS on DSP1 and DSP2, SMP-BIOS on IPU1
        and IPU2</li>
      </ul>
    </li>
  </ul>
</p>

<hr>
<h2><a name="Known_Issues">Known Issues</a></h2>
<ul>
</td>
</li>
  <li>If your application needs to
  <code>#include &lt;ti/ipc/transports/TransportRpmsg.h&gt;</code>
  then you must ensure that your compiler -I options are in the following
  correct order:
  <code>-I &lt;ipc&gt;/linux/include -I &lt;ipc&gt;/packages</code>.
  This is needed since the product erroneously contains a
  <code>ti/ipc/transports/TransportRpmsg.h</code>
  file in both locations, which will be fixed in an upcoming release.
  </li>
  <li>Examples are not yet provided for many devices.  If applicable,
  please refer to the SDK redistributing IPC for examples appropriate
  for your device.
  </li>
  <li>The HLOS-allocated vrings (in rpmsg-based environments) must
  currently be configured as non-cached from the slave side.  This is
  done in the typical, processor-specific way (e.g. MAR bits for C6x,
  AMMU for IPUs, etc.).  An enhancement is being considered to enable
  these vrings to be cached from the slave side.  That work is being
  tracked as SDOCM00106580.
  </li>
  <li>The MmRpc API on Linux currently requires out of mainline kernel
  support.  They are, therefore, not available for all devices.  TI
  will be working with the community to push these features
  mainline.  Until that is available, TI may provide kernels for
  select devices with support for MmRpc.
  </li>
  <li>The Linux MmRpc libraries are not pre-built (as they're not
  supported on all kernels) - users of those APIs are required to
  rebuild the IPC libraries as described in the IPC Install
  Guide.
  </li>
  <li>The IPC product build performs some industry-standard checks on
  the integrity of the source code.  Currently there are some issues
  that are flagged by these checks which we believe are benign.  We
  will be addressing these issues in a future release so as to get a
  clean "bill of health" from these source code checks.
  </li>
</ul>
<!--<p>
Consult the <a href="https://cqweb.ext.ti.com/cqweb/main?command=GenerateMainFrame&service=CQ&schema=SDO-Web&contextid=SDOWP&queryID=34483205&entityDefName=IncidentReport&username=readonly&password=readonly">SDOWP database</a> for open issues.
</p>
-->

<hr>
<h2><a name="Version">Version Information</a></h2>
<p>
This product's version follows a version format, <b>M.mm.pp.bb</b>,
where <b>M</b> is a single digit Major number, <b>mm</b> is 2 digit
minor number, <b>pp</b> is a 2 digit patch number, and <b>b</b> is an
unrestricted set of digits used as an incrementing build counter.
</p>

<p>
To support multiple side-by-side installations of the product, the
product version is encoded in the top level directory,
ex. <b>ipc_3_47_02_00</b>.
</p>

<p>
Subsequent releases of patch upgrades will be identified by the patch
number, e.g. IPC 3.22.01.XX with directory <b>ipc_3_22_01_XX</b>.
Typically, these patches only include critical bug fixes.
</p>

<hr>
<h2><a name="Support">Technical Support</a></h2>
<p>
For technical support, use the community forum
<a href="http://e2e.ti.com/">TI E2E Community</a>, or email
softwaresupport@ti.com.
</p>

<p>
Check the following web site for updates: <a href="http://software-dl.ti.com/dsps/dsps_public_sw/sdo_sb/targetcontent/ipc/index.html">http://software-dl.ti.com/dsps/dsps_public_sw/sdo_sb/targetcontent/ipc/index.html</a>
</p>

<hr>
<p>
Last updated: July 30, 2018
</p>
</body>
</html>
